#include <reg51.h>

//STRUCTS
struct package
{
  int processo;
  char parametro;
}; 


//PROTOTIPOS
void set_trata_req(void (*requisicao) (struct package pack));

void envia(struct package pack);

void monta_info_serial(char dado_rec);


//VARIAVEIS GLOBAIS
void (*rec) (struct package pack);
char dado_env;

struct package curr_pack;


//FUNCOES

/**                                                                                       
 * recebe o ponteiro da funo que ir tratar as requisies do celular.
 * limpa a struct package
 */
void set_trata_req(void (*requisicao) (struct package pack))
{
	rec = requisicao;
	
	curr_pack.processo = 0;
	curr_pack.parametro = 0;
}


void trata_serial(void) interrupt 4 using 1
{
	char dado_rec;
	
	if(TI)
	{
		P2 = 0xAA;
	   TI = 0;             //libera flag de interrupcao
	   SBUF = dado_env;    //evnia o dado
	   ES = 0;             //desabilita interrupcao da serial
	   while(!TI);         //espera transmitir
	   TI = 0;             //libera o flag da serial
	   ES = 1;             //habilita interrupcao da serial
	}
	
	if(RI)
	{
		dado_rec = SBUF;
		monta_info_serial(dado_rec);
		RI = 0;
	}
}


void envia(struct package pack)
{
	dado_env = pack.processo;
	TI = 1;
	while(TI);
	
	dado_env = pack.parametro;
	TI = 1;
	while(TI);
}


void monta_info_serial(char dado_rec){
	if(curr_pack.processo == 0)
	{
		curr_pack.processo = (int) dado_rec;
	}
	else if(curr_pack.parametro == 0){
		curr_pack.parametro = dado_rec;
		rec(curr_pack);
		
		curr_pack.processo = 0;
		curr_pack.parametro = 0;
	}
}
